#include "AudioFilter.h"

#define LOWPASS

//The lower the decay, the better the filter.
#define MAX_DECAY 100
#define DECAY 3


#define I_LEVELS 3

Sint32 Range(Sint32 max, Sint32 min, Sint16 val);

Sint64 iVals[]={0,0,0,0,0};

#define INT16_MAX 32767

int Divisor=0;

void AudioFilterInit()
{
	Divisor=(int)pow(MAX_DECAY/DECAY,I_LEVELS+1)/250;
}

void AudioFilter(Sint16 *data, int samples)
{
	int n,n2;
	static Sint64 avg=0;
	static Sint16 prevSam=0;

	if(Divisor==0)
	{
		printf("Zero divisor!\n");
		return;
	}

#ifdef LOWPASS
	{
		Sint16 dVal;
		for(n=0; n<samples; n++)
		{
			dVal=(*data)-prevSam;
			prevSam=*data;

			iVals[0]=(iVals[0]*(MAX_DECAY-DECAY))/MAX_DECAY;
			iVals[0]+=avg;

			avg=(avg*(MAX_DECAY-DECAY))/MAX_DECAY;
			avg+=dVal;


			for(n2=1; n2<I_LEVELS; n2++)
			{
				iVals[n2]=(iVals[n2]*(MAX_DECAY-DECAY))/MAX_DECAY;
				iVals[n2]+=iVals[n2-1];
			}

			*data=(Sint16)(iVals[I_LEVELS-1]/Divisor);
			data++;
		}
	}
#endif
}
